"use strict";
var Adapter = (function () {
    function Adapter(config) {
        if (config === void 0) { config = { bufferLogs: false }; }
        this.config = config;
        this.isFlushing = false;
        this.logBuffer = [];
    }
    Adapter.prototype.log = function (message) {
        var optionalParams = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            optionalParams[_i - 1] = arguments[_i];
        }
        while (this.isFlushing) {
            ;
        }
        this.logBuffer.push({ message: message, optionalParams: optionalParams, timestamp: new Date() });
        if (!this.config.bufferLogs) {
            this.flushBuffer(this.logger);
        }
    };
    Adapter.prototype.logger = function (logData) {
        var logEntry = logData.timestamp.toISOString() + " :: " + logData.message;
        console.log(logEntry, logData.optionalParams);
    };
    Adapter.prototype.flushBuffer = function (logger) {
        this.isFlushing = true;
        while (this.logBuffer.length !== 0) {
            var logData = this.logBuffer.shift();
            logger(logData);
        }
        this.isFlushing = false;
    };
    return Adapter;
}());
exports.Adapter = Adapter;

//# sourceMappingURL=../../../../maps/src/system/adapter/logger/console.js.map
