import { Promise } from "../core";
export declare abstract class IAdapter {
    name: string;
}
export declare abstract class ILogger {
    abstract log(message?: any, ...optionalParams: any[]): void;
}
import * as http from "http";
import { HttpVerb } from "../router/enums";
export declare abstract class IRouter {
    abstract addMiddleware(name: string, handler: any): void;
    abstract addRequestHandler(name: string, handler: any): void;
    abstract register(httpVerb: HttpVerb, path: string, handler: any): any;
}
export declare abstract class IFramework {
    router: IRouter;
    abstract startWebServer(port: number, hostname: string, callback?: Function): http.Server;
}
export declare abstract class ITask {
    abstract execute(): Promise<any>;
}
export declare abstract class IInitializer extends ITask {
}
export declare abstract class IDataAdapter<T> {
    provider: T;
    abstract initialize(cb: CallbackHandler): void;
}
export declare abstract class IDataContext {
    provider: any;
}
export interface TaskFinishedHandler {
    (error: any, data: any): void;
}
export interface CallbackHandler {
    (...args: any[]): void;
}
