import { Context } from "../core/context";
export declare abstract class WebServer {
    private static _instance;
    static start(): void;
    private logger;
    private _context;
    context: Context;
    private config;
    private tasks;
    constructor();
    execute(): void;
    private initializeSystem();
    private initializeApplication();
    private initializeConfiguration();
    private initializeAdapter();
    private registerAdapter(typeOfAdapter, name?);
    private initializeController();
    private initializeRequestHandler();
    private resolveModules(pathFragment);
    private resolveModulePath(path, filename);
    private initializeTasks();
    private initializeContext();
    private switchLogger();
    private initializeRoutes();
    private executeTasks();
    private onTaskSuccess(task);
    private onTaskError(task);
    onBeforeServerStart(): void;
    onAfterServerStart(): void;
    private startWebServer();
    private onServerStarted();
}
