import { ParamType } from "../router/enums";
import { RouteHandler } from "../router/handler";
export declare class RouteArea {
    targetClass: Function;
    path: string;
    handlers: Array<RouteHandler>;
    languages: Array<string>;
    accepts: Array<string>;
    properties: Array<ParamType>;
    constructor(targetClass: Function);
    addProperty(key: string, paramType: ParamType): void;
    hasProperties(): boolean;
}
export declare class FileParam {
    name: string;
    singleFile: boolean;
    constructor(name: string, singleFile: boolean);
}
export declare class MethodParam {
    name: string;
    type: Function;
    paramType: ParamType;
    constructor(name: string, type: Function, paramType: ParamType);
}
export declare class ResponseData {
    body: string;
    code: number;
    headers: {
        [id: string]: string;
    };
}
export declare class RequestContext {
    language: string;
    preferredMedia: string;
    request: any;
    response: any;
    next: any;
}
export declare abstract class HttpError extends Error {
    statusCode: number;
    message: string;
    constructor(name: string, statusCode: number, message?: string);
}
export declare abstract class ReferencedResource {
    location: string;
    statusCode: number;
    constructor(location: string, statusCode: number);
}
