import { Context } from "../core/context";
import { RouteArea } from "../router/metadata";
import { RouteHandler } from "../router/handler";
import { IRouter } from "../core/interfaces";
export declare class RouteRegistrar {
    private router;
    private context;
    private paths;
    private routeAreas;
    private httpHandler;
    private pathsResolved;
    constructor(router: IRouter, context: Context);
    addHttpHandler(target: any): RouteArea;
    addRouteArea(target: any): RouteArea;
    addRouteHandler(target: Function, methodName: string): RouteHandler;
    registerHttpHandler(path: string): void;
    registerRoutes(): void;
    private buildRoute(routeArea, routeHandler);
    private resolveProperties(routeArea, routeHandler);
    private resolvePath(routeArea, routeHandler);
}
